package cn.ey.biz.module.system.api.oauth2;

import cn.ey.biz.common.pojo.R;
import cn.ey.biz.module.system.api.oauth2.dto.*;
import cn.ey.biz.module.system.convert.auth.OAuth2ClientConvert;
import cn.ey.biz.module.system.convert.auth.OAuth2TokenConvert;
import cn.ey.biz.module.system.dal.dataobject.oauth2.OAuth2AccessTokenDO;
import cn.ey.biz.module.system.dal.dataobject.oauth2.OAuth2ClientDO;
import cn.ey.biz.module.system.service.oauth2.OAuth2ClientService;
import cn.ey.biz.module.system.service.oauth2.OAuth2TokenService;
import org.apache.dubbo.config.annotation.DubboService;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

import static cn.ey.biz.common.pojo.R.success;
import static cn.ey.biz.module.system.enums.ApiConstants.VERSION;

@RestController // 提供 RESTful API 接口，给 Feign 调用
@DubboService(version = VERSION) // 提供 Dubbo RPC 接口，给 Dubbo Consumer 调用
@Validated
public class OAuth2TokenApiImpl implements OAuth2TokenApi {

    @Resource
    private OAuth2TokenService oauth2TokenService;
    @Resource
    private OAuth2ClientService oauth2ClientService;

    @Override
    public R<OAuth2AccessTokenRespDTO> createAccessToken(OAuth2AccessTokenCreateReqDTO reqDTO) {
        OAuth2AccessTokenDO accessTokenDO = oauth2TokenService.createAccessToken(
                reqDTO.getUserId(), reqDTO.getUserType(), reqDTO.getClientId(), reqDTO.getScopes());
        return success(OAuth2TokenConvert.INSTANCE.convert2(accessTokenDO));
    }

    @Override
    public R<OAuth2AccessTokenRespDTO> createClientAccessToken(OAuth2AccessTokenClientCreateReqDTO reqDTO) {
        OAuth2AccessTokenDO accessTokenDO = oauth2TokenService.createClientAccessToken(reqDTO);
        return success(OAuth2TokenConvert.INSTANCE.convert2(accessTokenDO));
    }

    @Override
    public R<OAuth2ClientRespDTO> getClient(String clientId) {
        OAuth2ClientDO oauth2ClientDO = oauth2ClientService.validOAuthClientFromCache(clientId);
        return success(OAuth2ClientConvert.INSTANCE.convert2(oauth2ClientDO));
    }

    @Override
    public R<OAuth2AccessTokenCheckRespDTO> checkAccessToken(String accessToken) {
        return success(OAuth2TokenConvert.INSTANCE.convert(oauth2TokenService.checkAccessToken(accessToken)));
    }

    @Override
    public R<OAuth2AccessTokenRespDTO> removeAccessToken(String accessToken) {
        OAuth2AccessTokenDO accessTokenDO = oauth2TokenService.removeAccessToken(accessToken);
        return success(OAuth2TokenConvert.INSTANCE.convert2(accessTokenDO));
    }

    @Override
    public R<OAuth2AccessTokenRespDTO> refreshAccessToken(String refreshToken, String clientId) {
        OAuth2AccessTokenDO accessTokenDO = oauth2TokenService.refreshAccessToken(refreshToken, clientId);
        return success(OAuth2TokenConvert.INSTANCE.convert2(accessTokenDO));
    }

}
